#include<iostream>
#include <stdlib.h>
#include <climits>
#include <vector>
#include<algorithm>
using namespace std;

#define V 10
 
// Function taken from https://www.geeksforgeeks.org/traveling-salesman-problem-tsp-implementation/

extern int fxn(int s, int vertex[], int vs, int graph[][V]);

int travllingSalesmanProblem(int graph[][V])
{
  // store all vertex apart from source vertex
  int s = 0;
  std::vector<int> vertex;
  for (int i = 0; i < V; i++)
    if (i != s)
      vertex.push_back(i);

  // store minimum weight Hamiltonian Cycle.
  int min_path = INT_MAX;
  do
  {
    min_path = std::min(fxn(s,vertex.data(),vertex.size(),graph), min_path);
  } while (
      next_permutation(vertex.begin(), vertex.end()));

  return min_path;
}

int main(int argc, char** argv)
{
    const auto seed = argc > 1 ? atoi(argv[2]) : 0;
    srand (seed);
    auto graph = new int[V][V];

    for (int i = 0; i < V; i++) {
      graph[i][i] = 0;
      for (int j = 1; j < V; j++) {
        graph[i][j] = abs(rand()) % 10;
      }
    }
    for (int i = 1; i < V; i++) {
      graph[i][i] = 0;
      for (int j = 0; j < i; j++) {
        graph[i][j] = graph[j][i];
      }
    }





    cout << travllingSalesmanProblem(graph) << endl;
    return 0;
}
